Unit AMMIR_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMMIR(var IA :Array of Integer; var JA :Array of Integer;
                var IB :Array of Integer; var JB :Array of Integer;
                NP :Integer; NQ :Integer; NR :Integer;
                var IC :Array of Integer; var JC :Array of Integer;
                var IX :Array of Integer); 
implementation

procedure AMMIR(var IA :Array of Integer; var JA :Array of Integer;
                var IB :Array of Integer; var JB :Array of Integer;
                NP :Integer; NQ :Integer; NR :Integer;
                var IC :Array of Integer; var JC :Array of Integer;
                var IX :Array of Integer);
var
I,IP,IAA,IAB,JP,J,IBA,IBB,KP,K :Integer;
label
_10,_20,_30,_40;
begin

{           - }
{              ,   }
{         RR()U.       }
{      =     RR()U.   }


{   I, J -       RR()U;  }

{   I, J -       RR()U; }

{       N -      (: ); }

{       NQ -          }
{            (: ); }

{       NR -      (: ); }

{   I, J -         }
{            RR()U; }

{       I -     NR,   - }
{                }


{       I -     - }
{       J }

IP := 1;

{            I }

for I:=1 to NR do
 begin
_10:
  IX[I-1] := 0;
 end;

{             }

for I:=1 to NP do
 begin
  IC[I-1] := IP;
  IAA := IA[I-1];
  IAB := IA[I+0]-1;
  if ( IAB < IAA ) 
   then goto _40;

{          I     }

  for JP:=IAA to IAB do
   begin
    J := JA[JP-1];
    IBA := IB[J-1];
    IBB := IB[J+0]-1;
    if ( IBB < IBA ) 
     then goto _30;

{          J   }

    for KP:=IBA to IBB do
     begin
      K := JB[KP-1];

{      ,          I }
{        J;  ,      J }

      if ( IX[K-1] = I ) 
       then goto _20;
      JC[IP-1] := K;
      IP := IP+1;
      IX[K-1] := I;
_20:
     end;
_30:
   end;
_40:
 end;
IC[NP+0] := IP;
end;

end.
